import { CombineService, BaseOptions, BaseResult, LoadMoreFormatReturn, LoadMoreOptions, LoadMoreOptionsWithFormat, LoadMoreParams, LoadMoreResult, OptionsWithFormat, PaginatedFormatReturn, PaginatedOptionsWithFormat, PaginatedParams, PaginatedResult, BasePaginatedOptions } from '@ahooksjs/use-request/lib/types';
import { axios } from './request';
export interface Config {
    onErrorBefore?: (error?: Error, params?: any[]) => void;
}
export declare const config: (config: Config) => void;
export interface UseFetchOptions<R, P extends any[]> extends BaseOptions<R, P> {
    disabledErrorMessage?: boolean;
}
export interface UseFetchOptionsWithFormat<R = any, P extends any[] = any, U = any, UU extends U = any> extends OptionsWithFormat<R, P, U, UU> {
    disabledErrorMessage?: boolean;
}
export interface UseFetchLoadMoreOptions<R extends LoadMoreFormatReturn> extends LoadMoreOptions<R> {
    disabledErrorMessage?: boolean;
}
export interface UseFetchLoadMoreOptionsWithFormat<R extends LoadMoreFormatReturn, RR> extends LoadMoreOptionsWithFormat<R, RR> {
    disabledErrorMessage?: boolean;
}
export interface UseFetchPaginatedOptionsWithFormat<R, Item, U> extends PaginatedOptionsWithFormat<R, Item, U> {
    disabledErrorMessage?: boolean;
}
export interface UseFetchBasePaginatedOptions<U> extends BasePaginatedOptions<U> {
    disabledErrorMessage?: boolean;
}
declare function useFetch<R = any, P extends any[] = any, U = any, UU extends U = any>(service: CombineService<R, P>, options: UseFetchOptionsWithFormat<R, P, U, UU>): BaseResult<U, P>;
declare function useFetch<R = any, P extends any[] = any>(service: CombineService<R, P>, options?: UseFetchOptions<R, P>): BaseResult<R, P>;
declare function useFetch<R extends LoadMoreFormatReturn, RR>(service: CombineService<RR, LoadMoreParams<R>>, options: UseFetchLoadMoreOptionsWithFormat<R, RR>): LoadMoreResult<R>;
declare function useFetch<R extends LoadMoreFormatReturn, RR extends R>(service: CombineService<R, LoadMoreParams<R>>, options: UseFetchLoadMoreOptions<RR>): LoadMoreResult<R>;
declare function useFetch<R = any, Item = any, U extends Item = any>(service: CombineService<R, PaginatedParams>, options: UseFetchPaginatedOptionsWithFormat<R, Item, U>): PaginatedResult<Item>;
declare function useFetch<R = any, Item = any, U extends Item = any>(service: CombineService<PaginatedFormatReturn<Item>, PaginatedParams>, options: UseFetchBasePaginatedOptions<U>): PaginatedResult<Item>;
export { axios };
export default useFetch;
