"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "axios", {
  enumerable: true,
  get: function get() {
    return _axios["default"];
  }
});
exports["default"] = void 0;

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// eslint-disable-next-line @typescript-eslint/no-explicit-any
var transformURL = function transformURL(url, data) {
  if (!data) {
    return {
      url: url,
      data: data
    };
  }

  var cloneData = data;
  var cloneUrl = url;

  try {
    cloneData = JSON.parse(JSON.stringify(data));
  } catch (error) {}

  Object.entries(cloneData).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 1),
        key = _ref2[0];

    var reg = new RegExp("/:".concat(key));

    if (reg.test(cloneUrl)) {
      cloneUrl = cloneUrl.replace("/:".concat(key), "/".concat(cloneData[key]));
      delete cloneData[key];
    }
  });
  return {
    url: cloneUrl,
    data: cloneData
  };
};

var request = function request(config) {
  var params = config;

  if (_typeof(config) === 'object') {
    var axiosConfig = config;

    var _transformURL = transformURL(axiosConfig.url, axiosConfig.data),
        data = _transformURL.data,
        url = _transformURL.url;

    params = _objectSpread(_objectSpread({}, axiosConfig), {}, {
      data: data,
      url: url
    });

    if ((!params.method || params.method.toLocaleUpperCase() === 'GET') && !params.params) {
      params.params = data;
    }
  }

  return (_typeof(config) === 'object' ? (0, _axios["default"])(params) : (0, _axios["default"])(params)).then(function (response) {
    return Promise.resolve(response.data);
  })["catch"](function (error) {
    var response = error.response;
    var message;
    var statusCode = 0;

    if (response && response instanceof Object) {
      var _data = response.data,
          statusText = response.statusText;
      statusCode = response.status;
      message = _data.message || statusText;
    } else {
      // eslint-disable-next-line prefer-destructuring
      message = error.message;
    }

    return Promise.reject({
      statusCode: statusCode,
      message: message
    });
  });
};

var _default = request;
exports["default"] = _default;